﻿--mm_themesong
--20111019
--Author MMoose

mmthemesong = LibStub("AceAddon-3.0"):NewAddon("mmthemesong", "AceHook-3.0", "AceConsole-3.0", "AceEvent-3.0", "AceComm-3.0", "AceTimer-3.0")
local addon = mmthemesong
local function mmthemesongOptions()
    local options = {
        type = "group",
        name = "MM ThemeSong",
        args = {
            MMThemeSong = {
                order = 1,
				type = "group",
				name = "General Documentation",
				desc = "General Documentation",
				args = {
                    header1 = {
                        order = 1,
                        type = "header",
                        name = "General Documentation",                    
                    },
    				desc1 = {
	    				order	= 2,
		    			type	= "description",
			    		name	= [=[MM ThemeSong is a simple addon to allow you to define mp3 files that will play when your friends come online.
                            
                        -Usage
                            All mp3 files should be placed in Interfaces\AddOns\mm_themesong\sounds.
                            Once your mp3 files are in place, open your friends list and right click on a friend.
                            Click on the 'Edit Theme Song' option and type in the name of the mp3 with the extension.
                                I.E. myfriend.mp3
                            Click the Save button.
                            The next time that friend comes online, you will hear the mp3 you have chosen.
                            
                            To remove a theme song, follow the steps above but leave the mp3 blank.
                            
                        -NOTES
                            This AddOn now has support for RealID friends.  If there are any issues let me know.
                            
                            This AddOn has 2 modes of play.  
                            The default mode does not care how long the mp3 plays, it does not stop the mp3 before it is complete.
                            Care should be taken when deciding the length of the mp3 to put in place.
                            In this mode the sound volume is controlled by the Master volume.
                            
                            If you want to determine length of play time, or if you have several sound files attempting to play
                            at the same time, please try the UseOptionalSound setting.
                            In this mode the sound volume is controlled by the Music volume.
                            As always feedback is welcome.
                            
                            The AddOn author assumes no legal responsibility for your choice of mp3 files.  
                            All legal risk for questionable content falls upon the end user.
                            Please consider the legal ramifications of pirated mp3 files before using them
                            
                            If this needs to be localized for your location, please drop me a note.
                            
                        -Thanks
                            Thanks to "The Man of Many Raiths" for all the help in testing etc...
                            Thanks to "tumblesnowsinwhateverhisnameisthishour" for all the help in testing etc...
                            Thanks to "joscherjenwhateverhernameisthishour" for all the help in testing etc...
                            Thanks to Dark Sun Rising on Scarlet Crusade for putting up with the guildspam...
                            Thanks to various authors for code snips found searching the web, the AddOn community is amazing!
                            
                        Mmoose
                            ]=]
                            ,
		    		},
                },
            },
            Settings = {
                type = 'group',
			    name = "Settings",
			    desc = "Settings",
				args = {	
                desc1 = {
	    				order	= 2,
		    			type	= "description",
			    		name	= [=[Use Optional Sound is currently beta.
                        This allows you to set the time a sound file plays.
                        Set by checking the box and then setting your time limit.
                        Again, this is beta, please let me know if there are any issues.
                        
                        UseOptionalSound is tied into the 'Music' volume when used.
                        When UseOptionalSound is not being used, this addon uses the 'Master' volume.
                        
                        Mmoose
                            ]=]
                            ,
		    		},
            		usecountdown = {
						name = "UseOptionalSound",
						desc = "Use Timed Play Mode (Beta)",
						type = "toggle",
						get = function() return addon.db.profile.timercount end,
						set = function() addon.db.profile.timercount = not addon.db.profile.timercount end,
						order = 3,
					},
					counttime = {
						name = "PlayTime",
						desc = "Amount of time to play (Beta)",
						type = "input",
						set = function(info, value) addon.db.profile.counttime = tonumber(value) end,
						get = function() return tostring(addon.db.profile.counttime) end,
						order = 4,
					},
                },
            },
        },
    }
    return options
end
function mmthemesong:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("mmthemesongdb", defaults)
    LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("mmthemesong", mmthemesongOptions)
    local AceConfigDialog = LibStub("AceConfigDialog-3.0")
    self.optionsFrames = {}
    self.optionsFrames.MMThemeSong = AceConfigDialog:AddToBlizOptions("mmthemesong","MMThemeSong", nil, "MMThemeSong")
    self.optionsFrames.Settings = AceConfigDialog:AddToBlizOptions("mmthemesong","Settings", "MMThemeSong", "Settings")	
    mmthemesong.AddEditMenuItem()
	mmthemesong:RegisterEvent("PLAYER_ENTERING_WORLD")
	mmthemesong:RegisterEvent("PLAYER_LEAVING_WORLD")
    mmthemesong:RegisterEvent("CHAT_MSG_SYSTEM")
    mmthemesong:RegisterEvent("BN_FRIEND_ACCOUNT_ONLINE")
    mmthemesong.CreateFrame()
    mmthemesong.fnamestring = ""
    mmthemesong.fnme = ""
    mmthemesong.path = "Interface\\AddOns\\mm\_themesong\\sounds\\"
    self.db:RegisterDefaults(
		{ 
			profile =
			{
				timercount = false,
                counttime = 20
			}
		}
	)    

end
function mmthemesong:TimerFeedback()
	DEFAULT_CHAT_FRAME:AddMessage("ThemeSong Timer Expired")
	StopMusic()
end
function mmthemesong:EditThemeClick(self)
	local menu = UIDROPDOWNMENU_INIT_MENU
	local button = self.value
	if button == "themesongitem" then
		local fullname = nil
		local name = menu.name
		local server = menu.server
		if server and #server > 0 then
			local strFormat = "%s - %s"
			fullname = strFormat:format(name, server)
		else
			fullname = name
		end
       -- DEFAULT_CHAT_FRAME:AddMessage(fullname)
        mmthemesong:showtheframe(fullname)
	end
end
function mmthemesong:AddEditMenuItem()
	UnitPopupButtons["themesongitem"] = {text = "Edit Theme Song", dist = 0}
	mmthemesong:SecureHook("UnitPopup_OnClick", "EditThemeClick")
	tinsert(UnitPopupMenus["FRIEND"], (#UnitPopupMenus["FRIEND"])-1, "themesongitem")
	tinsert(UnitPopupMenus["FRIEND_OFFLINE"], (#UnitPopupMenus["FRIEND_OFFLINE"])-1, "themesongitem")
    tinsert(UnitPopupMenus["BN_FRIEND"], (#UnitPopupMenus["BN_FRIEND"])-1, "themesongitem")
    tinsert(UnitPopupMenus["BN_FRIEND_OFFLINE"], (#UnitPopupMenus["BN_FRIEND_OFFLINE"])-1, "themesongitem")
    
end
function mmthemesong:OnLoad()
end
function mmthemesong:RegisterEm()
end
function mmthemesong:ReleaseEm()
    mmthemesong:UnregisterEvent("CHAT_MSG_SYSTEM")
end
function mmthemesong:BN_FRIEND_ACCOUNT_ONLINE(ackl, presenceID)
    local presenceID, givenName, surname, toonName, toonID, client, isOnline, lastOnline, isAFK, isDND, messageText, noteText, isFriend, unknown = BNGetFriendInfoByID(presenceID)
    local fullname = format(BATTLENET_NAME_FORMAT, givenName, surname)
    if (client == BNET_CLIENT_WOW) then
        if ( fullname == nil or fullname == "") then
            return false;
        else 
            if(addon.db.profile[fullname] ~= nil) then
                if(addon.db.profile[fullname] ~= "") then
                    StopMusic()
					mmthemesong:CancelAllTimers()
                    if(addon.db.profile.timercount == true) then
                    	DEFAULT_CHAT_FRAME:AddMessage("Theme Song Playing for "..fullname.." for "..addon.db.profile.counttime.." seconds")
                        mmthemesong:ScheduleTimer("TimerFeedback", tonumber(addon.db.profile.counttime)) 
                        PlayMusic(mmthemesong.path..addon.db.profile[fullname])
                    else
                        PlaySoundFile(mmthemesong.path..addon.db.profile[fullname], "Master")
                    end
                end
            end
        end
    end
end
function mmthemesong:CHAT_MSG_SYSTEM(event, arg1, ...)
    if ( arg1 == nil or arg1 == "") then
        return false;
    else 
        if (string.find(string.lower(arg1), "online") ~= nil) then
            _, _, _, altname = string.find(arg1,"(.+)%[(.+)%](.+)");
            if(addon.db.profile[altname] ~= nil) then
                if(addon.db.profile[altname] ~= "") then
                    StopMusic()
                    mmthemesong:CancelAllTimers()
                    if(addon.db.profile.timercount == true) then
                    	DEFAULT_CHAT_FRAME:AddMessage("Theme Song Playing for "..altname.." for "..addon.db.profile.counttime.." seconds")
                        mmthemesong:ScheduleTimer("TimerFeedback", tonumber(addon.db.profile.counttime)) 
                        PlayMusic(mmthemesong.path..addon.db.profile[altname])
                    else
                        PlaySoundFile(mmthemesong.path..addon.db.profile[altname], "Master")
                    end
                end
            end
        end
    end
end
function mmthemesong:CreateFrame()
	if(addon.Frame) then
	end
	if (not addon.Frame) then
		-- Create the main Frame
		mmthemesong.Frame = CreateFrame("Frame", "mmthemesong.Frame", UIParent)
		mmthemesong.Frame:SetWidth(415)
		mmthemesong.Frame:SetHeight(100)
		mmthemesong.Frame:SetBackdrop(
		{
			bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
			edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
			tile="false",
			edgeSize = 16,
			insets = {
						left = 5,
						right = 5,
						top = 5,
						bottom = 5
					}
		})
		mmthemesong.Frame:SetBackdropColor(0, 0, 0)
		mmthemesong.Frame:EnableMouse(true)
		mmthemesong.Frame:EnableKeyboard(true)
		mmthemesong.Frame:SetMovable(true)
        mmthemesong.Frame:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
        mmthemesong.bwc = CreateFrame("Button", nil, nil, "UIPanelButtonTemplate")
		mmthemesong.bwc:SetParent(mmthemesong.Frame)
		mmthemesong.bwc:SetWidth(40)
		mmthemesong.bwc:SetHeight(14)
		mmthemesong.bwc:SetText("Save")
		mmthemesong.bwc:SetPoint("BOTTOM", mmthemesong.Frame, "BOTTOM", 0, 7)
		mmthemesong.bwc:SetPoint("LEFT", mmthemesong.Frame, "LEFT", 15, 0)
        mmthemesong.iieb2 = CreateFrame("EditBox", "mmthemesong.Frame", mmthemesong.Frame)
		mmthemesong.iieb2:SetParent(mmthemesong.Frame)
		mmthemesong.iieb2:SetPoint("TOPLEFT", mmthemesong.Frame, "TOPLEFT", 15, -45)
		mmthemesong.iieb2:SetFont("Fonts\\FRIZQT__.TTF", 12)
		mmthemesong.iieb2:SetWidth(375)
		mmthemesong.iieb2:SetHeight(32)
		mmthemesong.iieb2:SetBackdrop({
			bgFile="",
	        edgeFile="Interface\\Tooltips\\UI-Tooltip-Border",
		    tile="true",
			tileSize= 32,
	        edgeSize=10
		})
        mmthemesong.iief1 = mmthemesong.Frame:CreateFontString(nil, "OVERLAY")
		mmthemesong.iief1:SetHeight(40)
		mmthemesong.iief1:SetPoint("TOPLEFT", mmthemesong.Frame, "TOPLEFT", 15, -5)
		mmthemesong.iief1:SetFont("Fonts\\FRIZQT__.TTF", 12)
		mmthemesong.iief1:SetJustifyH('LEFT')
        mmthemesong.fnamestring = ""
		mmthemesong.iief1:SetText(mmthemesong.fnamestring)
        mmthemesong.Frame:Hide()
    end
end
function mmthemesong:showtheframe(arg1)
    mmthemesong.fnme = arg1
    local str
    str = "Setting Themesong for "..mmthemesong.fnme.."\nenter name of mp3 without the path\nall files should be in interface/addons/mmthemesong/sounds"
    mmthemesong.iief1:SetText(str)
    mmthemesong.Frame:Show()
    mmthemesong.bwc:SetScript("OnClick", function() mmthemesong.bwc_OnClick() end)
end
function mmthemesong:bwc_OnClick()
    local song = mmthemesong.iieb2:GetText()
    DEFAULT_CHAT_FRAME:AddMessage(mmthemesong.fnme.."=>"..song)
    addon.db.profile[mmthemesong.fnme] = song
    mmthemesong.iieb2:SetText("")
    mmthemesong.Frame:Hide()
end